Index: applications/editors/josm/plugins/czechaddress/log.xsl
===================================================================
--- applications/editors/josm/plugins/czechaddress/log.xsl	(revision 15461)
+++ applications/editors/josm/plugins/czechaddress/log.xsl	(revision 15461)
@@ -0,0 +1,53 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
+<xsl:template match="/">
+  <html>
+  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
+  <body>
+    <table border="1">
+      <tr bgcolor="#9acd32">
+        <th>Date</th>
+        <th>Level</th>
+        <th>Message</th>
+        <th>Method</th>
+        <th>Param</th>
+      </tr>
+      <xsl:for-each select="log/record">
+      <tr>
+        <td><font size="-3"><xsl:value-of select="date"/></font></td>
+        <xsl:choose>
+            <xsl:when test="level = 'FINEST'">
+                <td><font color='#AAAAAA'><xsl:value-of select="level"/></font></td>
+                <td><xsl:value-of select="message"/></td>
+            </xsl:when>
+            <xsl:when test="level = 'FINER'">
+                <td><font color='#999999'><xsl:value-of select="level"/></font></td>
+                <td><xsl:value-of select="message"/></td>
+            </xsl:when>
+            <xsl:when test="level = 'FINE'">
+                <td><font color='#444444'><xsl:value-of select="level"/></font></td>
+                <td><xsl:value-of select="message"/></td>
+            </xsl:when>
+            <xsl:when test="level = 'INFO'">
+                <td><font color='black'><b><xsl:value-of select="level"/></b></font></td>
+                <td><b><xsl:value-of select="message"/></b></td>
+            </xsl:when>
+            <xsl:when test="level = 'WARNING'">
+                <td><font color='red'><b><xsl:value-of select="level"/></b></font></td>
+                <td><b><xsl:value-of select="message"/></b></td>
+            </xsl:when>
+            <xsl:otherwise>
+                <td><xsl:value-of select="level"/></td>
+            </xsl:otherwise>
+        </xsl:choose>
+        <td><tt><xsl:value-of select="method"/></tt></td>
+        <td><xsl:value-of select="param"/></td>
+      </tr>
+      </xsl:for-each>
+    </table>
+  </body>
+  </html>
+</xsl:template>
+</xsl:stylesheet>
+
+
Index: applications/editors/josm/plugins/czechaddress/logger.dtd
===================================================================
--- applications/editors/josm/plugins/czechaddress/logger.dtd	(revision 15461)
+++ applications/editors/josm/plugins/czechaddress/logger.dtd	(revision 15461)
@@ -0,0 +1,227 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+<!--
+ Licensed to the Apache Software Foundation (ASF) under one or more
+ contributor license agreements.  See the NOTICE file distributed with
+ this work for additional information regarding copyright ownership.
+ The ASF licenses this file to You under the Apache License, Version 2.0
+ (the "License"); you may not use this file except in compliance with
+ the License.  You may obtain a copy of the License at
+
+      http://www.apache.org/licenses/LICENSE-2.0
+
+ Unless required by applicable law or agreed to in writing, software
+ distributed under the License is distributed on an "AS IS" BASIS,
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ See the License for the specific language governing permissions and
+ limitations under the License.
+-->
+
+<!-- Authors: Chris Taylor, Ceki Gulcu. -->
+
+<!-- Version: 1.2 -->
+
+<!-- A configuration element consists of optional renderer
+elements,appender elements, categories and an optional root
+element. -->
+
+<!ELEMENT log4j:configuration (renderer*, appender*,plugin*, (category|logger)*,root?,
+                               (categoryFactory|loggerFactory)?)>
+
+<!-- The "threshold" attribute takes a level value below which -->
+<!-- all logging statements are disabled. -->
+
+<!-- Setting the "debug" enable the printing of internal log4j logging   -->
+<!-- statements.                                                         -->
+
+<!-- By default, debug attribute is "null", meaning that we not do touch -->
+<!-- internal log4j logging settings. The "null" value for the threshold -->
+<!-- attribute can be misleading. The threshold field of a repository	 -->
+<!-- cannot be set to null. The "null" value for the threshold attribute -->
+<!-- simply means don't touch the threshold field, the threshold field   --> 
+<!-- keeps its old value.                                                -->
+     
+<!ATTLIST log4j:configuration
+  xmlns:log4j              CDATA #FIXED "http://jakarta.apache.org/log4j/" 
+  threshold                (all|trace|debug|info|warn|error|fatal|off|null) "null"
+  debug                    (true|false|null)  "null"
+  reset                    (true|false) "false"
+>
+
+<!-- renderer elements allow the user to customize the conversion of  -->
+<!-- message objects to String.                                       -->
+
+<!ELEMENT renderer EMPTY>
+<!ATTLIST renderer
+  renderedClass  CDATA #REQUIRED
+  renderingClass CDATA #REQUIRED
+>
+
+<!-- Appenders must have a name and a class. -->
+<!-- Appenders may contain an error handler, a layout, optional parameters -->
+<!-- and filters. They may also reference (or include) other appenders. -->
+<!ELEMENT appender (errorHandler?, param*,
+      rollingPolicy?, triggeringPolicy?, connectionSource?,
+      layout?, filter*, appender-ref*)>
+<!ATTLIST appender
+  name 		CDATA 	#REQUIRED
+  class 	CDATA	#REQUIRED
+>
+
+<!ELEMENT layout (param*)>
+<!ATTLIST layout
+  class		CDATA	#REQUIRED
+>
+
+<!ELEMENT filter (param*)>
+<!ATTLIST filter
+  class		CDATA	#REQUIRED
+>
+
+<!-- ErrorHandlers can be of any class. They can admit any number of -->
+<!-- parameters. -->
+
+<!ELEMENT errorHandler (param*, root-ref?, logger-ref*,  appender-ref?)> 
+<!ATTLIST errorHandler
+   class        CDATA   #REQUIRED 
+>
+
+<!ELEMENT root-ref EMPTY>
+
+<!ELEMENT logger-ref EMPTY>
+<!ATTLIST logger-ref
+  ref CDATA #REQUIRED
+>
+
+<!ELEMENT param EMPTY>
+<!ATTLIST param
+  name		CDATA   #REQUIRED
+  value		CDATA	#REQUIRED
+>
+
+
+<!-- The priority class is org.apache.log4j.Level by default -->
+<!ELEMENT priority (param*)>
+<!ATTLIST priority
+  class   CDATA	#IMPLIED
+  value	  CDATA #REQUIRED
+>
+
+<!-- The level class is org.apache.log4j.Level by default -->
+<!ELEMENT level (param*)>
+<!ATTLIST level
+  class   CDATA	#IMPLIED
+  value	  CDATA #REQUIRED
+>
+
+
+<!-- If no level element is specified, then the configurator MUST not -->
+<!-- touch the level of the named category. -->
+<!ELEMENT category (param*,(priority|level)?,appender-ref*)>
+<!ATTLIST category
+  class         CDATA   #IMPLIED
+  name		CDATA	#REQUIRED
+  additivity	(true|false) "true"  
+>
+
+<!-- If no level element is specified, then the configurator MUST not -->
+<!-- touch the level of the named logger. -->
+<!ELEMENT logger (level?,appender-ref*)>
+<!ATTLIST logger
+  name		CDATA	#REQUIRED
+  additivity	(true|false) "true"  
+>
+
+
+<!ELEMENT categoryFactory (param*)>
+<!ATTLIST categoryFactory 
+   class        CDATA #REQUIRED>
+
+<!ELEMENT loggerFactory (param*)>
+<!ATTLIST loggerFactory
+   class        CDATA #REQUIRED>
+
+<!ELEMENT appender-ref EMPTY>
+<!ATTLIST appender-ref
+  ref CDATA #REQUIRED
+>
+
+<!-- plugins must have a name and class and can have optional parameters -->
+<!ELEMENT plugin (param*, connectionSource?)>
+<!ATTLIST plugin
+  name 		CDATA 	   #REQUIRED
+  class 	CDATA  #REQUIRED
+>
+
+<!ELEMENT connectionSource (dataSource?, param*)>
+<!ATTLIST connectionSource
+  class        CDATA  #REQUIRED
+>
+
+<!ELEMENT dataSource (param*)>
+<!ATTLIST dataSource
+  class        CDATA  #REQUIRED
+>
+
+<!ELEMENT triggeringPolicy ((param|filter)*)>
+<!ATTLIST triggeringPolicy
+  name 		CDATA  #IMPLIED
+  class 	CDATA  #REQUIRED
+>
+
+<!ELEMENT rollingPolicy (param*)>
+<!ATTLIST rollingPolicy
+  name 		CDATA  #IMPLIED
+  class 	CDATA  #REQUIRED
+>
+
+
+<!-- If no priority element is specified, then the configurator MUST not -->
+<!-- touch the priority of root. -->
+<!-- The root category always exists and cannot be subclassed. -->
+<!ELEMENT root (param*, (priority|level)?, appender-ref*)>
+
+
+<!-- ==================================================================== -->
+<!--                       A logging event                                -->
+<!-- ==================================================================== -->
+<!ELEMENT log4j:eventSet (log4j:event*)>
+<!ATTLIST log4j:eventSet
+  xmlns:log4j             CDATA #FIXED "http://jakarta.apache.org/log4j/" 
+  version                (1.1|1.2) "1.2" 
+  includesLocationInfo   (true|false) "true"
+>
+
+
+
+<!ELEMENT log4j:event (log4j:message, log4j:NDC?, log4j:throwable?, 
+                       log4j:locationInfo?, log4j:properties?) >
+
+<!-- The timestamp format is application dependent. -->
+<!ATTLIST log4j:event
+    logger     CDATA #REQUIRED
+    level      CDATA #REQUIRED
+    thread     CDATA #REQUIRED
+    timestamp  CDATA #REQUIRED
+    time       CDATA #IMPLIED
+>
+
+<!ELEMENT log4j:message (#PCDATA)>
+<!ELEMENT log4j:NDC (#PCDATA)>
+
+<!ELEMENT log4j:throwable (#PCDATA)>
+
+<!ELEMENT log4j:locationInfo EMPTY>
+<!ATTLIST log4j:locationInfo
+  class  CDATA	#REQUIRED
+  method CDATA	#REQUIRED
+  file   CDATA	#REQUIRED
+  line   CDATA	#REQUIRED
+>
+
+<!ELEMENT log4j:properties (log4j:data*)>
+
+<!ELEMENT log4j:data EMPTY>
+<!ATTLIST log4j:data
+  name   CDATA	#REQUIRED
+  value  CDATA	#REQUIRED
+>
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/CzechAddressPlugin.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/CzechAddressPlugin.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/CzechAddressPlugin.java	(revision 15461)
@@ -27,5 +27,6 @@
 import org.openstreetmap.josm.plugins.czechaddress.actions.ModifierAction;
 import org.openstreetmap.josm.plugins.czechaddress.actions.SplitAreaByEmptyWayAction;
-import org.openstreetmap.josm.plugins.czechaddress.gui.DatabaseModifier;
+import org.openstreetmap.josm.plugins.czechaddress.gui.Inspector;
+import org.openstreetmap.josm.plugins.czechaddress.gui.Renamer;
 import org.openstreetmap.josm.plugins.czechaddress.gui.FactoryDialog;
 import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
@@ -46,10 +47,13 @@
             new ArrayList<AbstractButton>();
 
-    static private Reasoner mainReasoner = null;
-    static private Database mainDatabase = null;
+    static public Reasoner reasoner = null;
+    static public Database database = null;
 
-    public SelectionMonitor        selectionMonitor = null;
-    static public FactoryDialog    factoryDialog    = null;
-    static public ConflictResolver conflictResolver = null;
+    static public FactoryDialog     factoryDialog    = null;
+    static public ConflictResolver  conflictResolver = null;
+
+    static public Renamer   renamer  = null;
+    static public Inspector inspector = null;
+
 
     static private String pluginDir = null;
@@ -58,19 +62,19 @@
 
         pluginDir = getPluginDir();
+        addStatusListener(this);
 
-        factoryDialog    = FactoryDialog.getInstance();
+        factoryDialog    = new FactoryDialog();
         conflictResolver = new ConflictResolver();
 
-        addStatusListener(this);
-        addStatusListener(conflictResolver);
-
+        
         MainMenu.add(Main.main.menu.toolsMenu, new SplitAreaByEmptyWayAction());
 
+
         // Prepare for filling the database.
-        mainDatabase = new Database();
+        database = new Database();
         final MvcrParser parser = new MvcrParser();
         //parser.setFilter(null, null, null, "");
         //parser.setFilter("HUSTOPEČE", "HUSTOPEČE", null, null);
-        parser.setTargetDatabase(mainDatabase);
+        parser.setTargetDatabase(database);
         parser.setStorageDir(pluginDir);
 
@@ -80,5 +84,5 @@
             try {
                parser.fillDatabase();
-               broadcastStatusChanged(StatusListener.MESSAGE_DATABASE_LOADED);
+               broadcastStatusChange(StatusListener.MESSAGE_DATABASE_LOADED);
             } catch (DatabaseLoadException dle) {
                dle.printStackTrace();
@@ -95,19 +99,9 @@
     public void mapFrameInitialized(MapFrame oldFrame, MapFrame newFrame) {
 
-        super.mapFrameInitialized(oldFrame, newFrame);
-
         if (newFrame == null)
             return;
         
-        newFrame.addToggleDialog(FactoryDialog.getInstance());
+        newFrame.addToggleDialog(factoryDialog);
         newFrame.addMapMode(new IconToggleButton(new FactoryAction(newFrame)));
-    }
-
-    public static Reasoner getReasoner() {
-        return mainReasoner;
-    }
-
-    public static Database getDatabase() {
-        return mainDatabase;
     }
 
@@ -121,14 +115,14 @@
 
         // Update database according to the map
-        (new DatabaseModifier()).setVisible(true);
+        (new Renamer()).setVisible(true);
+        (new Inspector()).setVisible(true);
 
         // And add them to the reasoner.
-        mainReasoner = new Reasoner(pool);
-        mainReasoner.addPrimitives(Main.ds.allPrimitives());
+        reasoner = new Reasoner(pool);
+        reasoner.addPrimitives(Main.ds.allPrimitives());
     }
 
     static private ElementWithStreets location = null;
-
-    static public ElementWithStreets getLocation() {
+    static public  ElementWithStreets getLocation() {
         if (location == null)
             changeLocation();
@@ -142,27 +136,5 @@
         if (newLocation != null && newLocation != location) {
             location = newLocation;
-
-            /*
-            // Parse the database once more to get the streets and houses.
-            MvcrParser     parser   = new MvcrParser();
-            ParentResolver resolver = new ParentResolver(location);
-
-            parser.setFilter(resolver.parentRegion == null ? null : resolver.parentRegion.getName(),
-                             resolver.parentViToCi == null ? null : resolver.parentViToCi.getName(),
-                             resolver.parentSuburb == null ? null : resolver.parentSuburb.getName(),
-                             resolver.parentStreet == null ? null : resolver.parentStreet.getName());
-
-            parser.setTargetDatabase(mainDatabase);
-            parser.setStorageDir(pluginDir);
-            try {
-                parser.fillDatabase();
-            } catch (DatabaseLoadException dle) {
-               dle.printStackTrace();
-               System.err.println("CzechAddress: " +
-                            "Selhalo načtení databáze. A teď se budou dít divy...");
-            }*/
-
-            broadcastStatusChanged(StatusListener.MESSAGE_LOCATION_CHANGED);
-            initReasoner();
+            broadcastStatusChange(MESSAGE_LOCATION_CHANGED);
         }
     }
@@ -182,5 +154,5 @@
     }
 
-    static public void broadcastStatusChanged(int statusMessage) {
+    static public void broadcastStatusChange(int statusMessage) {
         for (StatusListener l : listeners)
             l.pluginStatusChanged(statusMessage);
@@ -188,5 +160,5 @@
 
     public void pluginStatusChanged(int message) {
-        if (message == StatusListener.MESSAGE_DATABASE_LOADED) {
+        if (message == MESSAGE_DATABASE_LOADED) {
             czechMenu = Main.main.menu.addMenu("Adresy", KeyEvent.VK_A, 4);
             menuItems.add(MainMenu.add(czechMenu, new PointManipulatorAction()));
@@ -198,4 +170,10 @@
         }
 
+        if (message == MESSAGE_LOCATION_CHANGED) {
+            initReasoner();
+            return;
+        }
+
+
         // SelectionMonitor cannot be used because of synchronization problems.
         /*if (message == MESSAGE_REASONER_REASONED) {
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StatusListener.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StatusListener.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StatusListener.java	(revision 15461)
@@ -3,5 +3,4 @@
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.AddressElement;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.Database;
-import org.openstreetmap.josm.plugins.czechaddress.parser.DatabaseParser;
 import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
 
@@ -67,5 +66,4 @@
      *
      * @see CzechAddressPlugin
-     * @see DatabaseParser
      * @see Database
      */
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StringUtils.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StringUtils.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/StringUtils.java	(revision 15461)
@@ -43,6 +43,5 @@
 
     public static String latLonToString(LatLon position) {
-        assert position != null;
-        //if (position == null) return "";
+        if (position == null) return "";
 
         return "(lat: " + coordinateToString(position.lat())
@@ -83,3 +82,38 @@
     }
 
+    /**
+     * Capitalizes the given string (first letter of every word upper-case,
+     * others lower-case). Czech grammar rules are more or less obeyed.
+     *
+     * <p><b>TODO:</b> This should be moved somewhere else.</p>
+     *
+     * @param s string to be capitalized
+     * @return capitaized string
+     */
+    public static String capitalize(String s) {
+
+        if (s == null)
+            return s;
+
+        String result = "";
+
+        char last = ' ';
+        for (char ch : s.toCharArray()) {
+            if ((last >= 'a') && (last <= 'ž') ||
+                (last >= 'A') && (last <= 'Ž'))
+                ch = Character.toLowerCase(ch);
+            else
+                ch = Character.toTitleCase(ch);
+
+            last = ch;
+            result = result + ch;
+        }
+
+        String[] noCapitalize = { "Nad", "Pod", "U", "Na" };
+        for (String noc : noCapitalize)
+            result = result.replaceAll(" "+noc+" ", " "+noc.toLowerCase()+" ");
+
+        return result;
+    }
+
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/FactoryAction.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/FactoryAction.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/FactoryAction.java	(revision 15461)
@@ -11,5 +11,4 @@
 import org.openstreetmap.josm.plugins.czechaddress.CzechAddressPlugin;
 import org.openstreetmap.josm.plugins.czechaddress.addressdatabase.House;
-import org.openstreetmap.josm.plugins.czechaddress.intelligence.Reasoner;
 import org.openstreetmap.josm.plugins.czechaddress.proposal.ProposalContainer;
 import org.openstreetmap.josm.tools.ImageProvider;
@@ -54,13 +53,12 @@
         Main.map.mapView.addMouseListener(this);
 
-        Reasoner r = CzechAddressPlugin.getReasoner();
-
-        if (r == null) {
+        if (CzechAddressPlugin.reasoner == null) {
             exitMode();
             return;
         }
 
-        FactoryDialog d = FactoryDialog.getInstance();
-        if (r.translate(d.getSelectedHouse()) != null)
+        // Switch to next unassigned house.
+        FactoryDialog d = CzechAddressPlugin.factoryDialog;
+        if (CzechAddressPlugin.reasoner.translate(d.getSelectedHouse()) != null)
             d.selectNextUnmatchedHouseByCheckBox();
     }
@@ -88,5 +86,5 @@
 
         // Get the currently selected House in the FactoryDialog.
-        House house = FactoryDialog.getInstance().getSelectedHouse();
+        House house = CzechAddressPlugin.factoryDialog.getSelectedHouse();
         if (house == null)
             return; // TODO: Some meaningful messageBox would be useful.
@@ -99,13 +97,10 @@
         container.applyAll();
 
-        // Notify reasoner about this newly added node.
-        CzechAddressPlugin.getReasoner().overwriteMatch(house, newNode);
-
         // And make the new node selected.
         Main.ds.addPrimitive(newNode);
         Main.ds.setSelected(newNode);
 
-        // And do not forget to select next House in the list.
-        FactoryDialog.getInstance().selectNextUnmatchedHouseByCheckBox();
+        CzechAddressPlugin.reasoner.overwriteMatch(house, newNode);
+        CzechAddressPlugin.factoryDialog.selectNextUnmatchedHouseByCheckBox();
     }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/ModifierAction.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/ModifierAction.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/actions/ModifierAction.java	(revision 15461)
@@ -9,5 +9,5 @@
 import java.awt.event.KeyEvent;
 import org.openstreetmap.josm.actions.JosmAction;
-import org.openstreetmap.josm.plugins.czechaddress.gui.DatabaseModifier;
+import org.openstreetmap.josm.plugins.czechaddress.gui.Renamer;
 import org.openstreetmap.josm.tools.Shortcut;
 
@@ -17,6 +17,4 @@
  */
 public class ModifierAction extends JosmAction {
-
-//    DatabaseModifier modifier = null;
 
     public ModifierAction() {
@@ -31,5 +29,5 @@
 
     public void actionPerformed(ActionEvent e) {
-        (new DatabaseModifier()).setVisible(true);
+        (new Renamer()).setVisible(true);
     }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/AddressElement.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/AddressElement.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/AddressElement.java	(revision 15461)
@@ -31,13 +31,9 @@
     /**
      * Constructor setting the name of this element.
-     *
-     * <p><b>TODO:</b> The name is capitalized during the assignment,
-     * because the database contains all names IN CAPITALS. However
-     * this should not be done here, but in the {@link DatabaseParser}.</p>
      */
     public AddressElement (String name) {
         if (name == null)
             throw new NullPointerException("You must specify the name of this AddressElement");
-        this.name = capitalize(name);
+        this.name = name;
     }
 
@@ -166,39 +162,4 @@
 
     /**
-     * Capitalizes the given string (first letter of every word upper-case,
-     * others lower-case). Czech grammar rules are more or less obeyed.
-     *
-     * <p><b>TODO:</b> This should be moved somewhere else.</p>
-     * 
-     * @param s string to be capitalized
-     * @return capitaized string
-     */
-    protected static String capitalize(String s) {
-
-        if (s == null)
-            return s;
-
-        String result = "";
-
-        char last = ' ';
-        for (char ch : s.toCharArray()) {
-            if ((last >= 'a') && (last <= 'ž') ||
-                (last >= 'A') && (last <= 'Ž'))
-                ch = Character.toLowerCase(ch);
-            else
-                ch = Character.toTitleCase(ch);
-
-            last = ch;
-            result = result + ch;
-        }
-
-        String[] noCapitalize = { "Nad", "Pod", "U", "Na" };
-        for (String noc : noCapitalize)
-            result = result.replaceAll(" "+noc+" ", " "+noc.toLowerCase()+" ");
-
-        return result;
-    }
-    
-    /**
      * Compute differences between two strings.
      *
@@ -248,4 +209,8 @@
     public List<Proposal> getDiff(OsmPrimitive prim) {
         return null;
+    }
+
+    public boolean isMatchable(OsmPrimitive prim) {
+        return false;
     }
 
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/House.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/House.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/House.java	(revision 15461)
@@ -204,4 +204,13 @@
     }
 
-
+    public boolean isMatchable(OsmPrimitive prim) {
+        
+        for (String key : prim.keySet()) {
+            String value = prim.get(key);
+            if (value != null && value.startsWith("addr:"))
+                return true;
+        }
+
+        return false;
+    }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Region.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Region.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/addressdatabase/Region.java	(revision 15461)
@@ -69,6 +69,6 @@
     public Region(String name, String nuts3name, String nuts4name) {
         super(name);
-        if (nuts3name != null) this.nuts3name = capitalize(nuts3name);
-        if (nuts4name != null) this.nuts4name = capitalize(nuts4name);
+        if (nuts3name != null) this.nuts3name = nuts3name;
+        if (nuts4name != null) this.nuts4name = nuts4name;
     }
     
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.java	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ConflictResolver.java	(revision 15461)
@@ -258,5 +258,5 @@
              if (best != null) best.qualityChanged();
 
-             List<Match> competitors = r.getConflicts((OsmPrimitive) selMainObj);
+             List<Match> competitors = r.conflicts((OsmPrimitive) selMainObj);
              if (competitors != null) for (Match competitor : competitors)
                  competitor.qualityChanged();
@@ -271,5 +271,5 @@
             if (best != null) best.qualityChanged();
 
-            List<Match> competitors = r.getConflicts((AddressElement) selMainObj);
+            List<Match> competitors = r.conflicts((AddressElement) selMainObj);
             if (competitors != null) for (Match competitor : competitors)
                  competitor.qualityChanged();
@@ -333,5 +333,5 @@
 
                 if (parent instanceof AddressElement)
-                    return r.getConflicts((AddressElement) parent).get(index).prim;
+                    return r.conflicts((AddressElement) parent).get(index).prim;
 
             } catch (Exception e) {  }
@@ -347,5 +347,5 @@
 
                 if (parent instanceof AddressElement)
-                    return r.getConflicts((AddressElement) parent).size();
+                    return r.conflicts((AddressElement) parent).size();
                 
             } catch (Exception exp) { }
@@ -361,5 +361,5 @@
 
                 if (parent instanceof AddressElement)
-                    return r.getConflicts((AddressElement) parent).indexOf(child);
+                    return r.conflicts((AddressElement) parent).indexOf(child);
                 
             } catch (Exception exp) { }
@@ -383,5 +383,5 @@
 
                 if (parent instanceof OsmPrimitive)
-                    return r.getConflicts((OsmPrimitive) parent).get(index).elem;
+                    return r.getConflictsconflictsve) parent).get(index).elem;
                 
             } catch (Exception exp) { }
@@ -397,5 +397,5 @@
                     return r.getPrimitivesInConflict().size();
                 if (parent instanceof OsmPrimitive)
-                    return r.getConflicts((OsmPrimitive) parent).size();
+                    return r.getConflictsconflictsve) parent).size();
 
             } catch (Exception exp) { }
@@ -412,5 +412,5 @@
 
                 } else if (parent instanceof OsmPrimitive)
-                    return r.getConflicts((OsmPrimitive) parent).indexOf(child);
+                    return r.getConflictsconflictsve) parent).indexOf(child);
                 
             } catch (Exception exp) { }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.form
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.form	(revision 15203)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/FactoryDialog.form	(revision 15461)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8" ?>
 
-<Form version="1.3" type="org.netbeans.modules.form.forminfo.JPanelFormInfo">
+<Form version="1.3" maxVersion="1.3" type="org.netbeans.modules.form.forminfo.JPanelFormInfo">
   <AuxValues>
     <AuxValue name="FormSettings_autoResourcing" type="java.lang.Integer" value="0"/>
@@ -26,5 +26,5 @@
           <Group type="103" groupAlignment="0" attributes="0">
               <Group type="102" attributes="0">
-                  <Component id="streetComboBox" pref="50" max="32767" attributes="0"/>
+                  <Component id="streetComboBox" pref="92" max="32767" attributes="0"/>
                   <EmptySpace max="-2" attributes="0"/>
                   <Component id="relocateButton" min="-2" max="-2" attributes="0"/>
@@ -33,5 +33,5 @@
               </Group>
               <Group type="102" alignment="0" attributes="0">
-                  <Component id="keepOddityCheckBox" pref="282" max="32767" attributes="0"/>
+                  <Component id="keepOddityCheckBox" pref="278" max="32767" attributes="0"/>
                   <EmptySpace max="-2" attributes="0"/>
               </Group>
